import{getQueryParameters,getDataParameters,downloadAsBlob,createEvent,waitFor,isEmpty,merge,sleep}from"../base/helpers.mjs";import{Session}from"../base/session.mjs";import{Publisher}from"../base/publisher.mjs";import{TooltipHelper}from"../common/tooltip.mjs";import{MenuView,SidebarView}from"../view/menu.mjs";import{StatusView}from"../view/status.mjs";import{NotificationCenterView}from"../view/notifications.mjs";import{WindowsView}from"../nodes/windows.mjs";import{ImageView,BackgroundImageView}from"../view/image.mjs";import{VideoView,VideoPlayerView}from"../view/video.mjs";import{Model}from"../model/enfugue.mjs";import{View}from"../view/base.mjs";import{ControlsHelperView}from"../view/controls.mjs";import{ModelMetadataView}from"../view/models.mjs";import{FileNameFormView}from"../forms/enfugue/files.mjs";import{StringInputView}from"../forms/input.mjs";import{InvocationController}from"../controller/common/invocation.mjs";import{SamplesController}from"../controller/common/samples.mjs";import{ModelPickerController}from"../controller/common/model-picker.mjs";import{ModelManagerController}from"../controller/common/model-manager.mjs";import{DownloadsController}from"../controller/common/downloads.mjs";import{LayersController}from"../controller/common/layers.mjs";import{PromptTravelController}from"../controller/common/prompts.mjs";import{AnimationsController}from"../controller/common/animations.mjs";import{ThemeController}from"../controller/common/theme.mjs";import{LayoutController}from"../controller/common/layout.mjs";import{AnnouncementsController}from"../controller/common/announcements.mjs";import{HistoryDatabase}from"../common/history.mjs";import{SimpleNotification}from"../common/notify.mjs";import{CheckpointInputView,LoraInputView,LycorisInputView,InversionInputView,ModelPickerInputView,DefaultVaeInputView,MotionModuleInputView}from"../forms/input.mjs";import{ConfirmFormView,YesNoFormView}from"../forms/confirm.mjs";import{ImageEditorView,ImageEditorNodeView,ImageEditorImageNodeView}from"../nodes/image-editor.mjs";class LogoutButtonView extends View{static tagName="i";static className="fa-solid fa-right-from-bracket logout";async logout(){window.location="/logout"}async build(){let e=await super.build();return e.on("click",(()=>this.logout())),e.data("tooltip","Logout"),e}}class Application{static menuCategories={file:"File"};static adminMenuCategories={models:"Models",system:"System"};static menuCategoryShortcuts={file:"f",models:"m",system:"s",extras:"e",layout:"l",theme:"t",help:"h"};static filenameFormInputWidth=400;static filenameFormInputHeight=250;static metadataWindowWidth=1e3;static metadataWindowHeight=550;static logoShadowRGB=[0,0,0];static logoShadowOpacity=.5;static logoShadowSteps=10;static logoShadowOffset=2;static logoShadowSpread=0;static confirmViewWidth=500;static confirmViewHeight=200;constructor(e){isEmpty(window.enfugue)||isEmpty(window.enfugue.config)||(e=merge(e,window.enfugue.config)),this.config=e,this.publisher=new Publisher(this.config.debug)}async initialize(){this.mouseX=0,this.mouseY=0,this.tooltips=new TooltipHelper,this.container=document.querySelector(this.config.view.applicationContainer),isEmpty(this.container)?console.error(`Couldn't find application configuration using selector ${this.config.view.applicationContainer}, abandoning initialization.`):(this.container.classList.add("loader"),this.container.classList.add("loading"),this.session=Session.getScope("enfugue",2592e6),this.model=new Model(this.config),this.menu=new MenuView(this.config),this.sidebar=new SidebarView(this.config),this.windows=new WindowsView(this.config),this.notifications=new NotificationCenterView(this.config),this.history=new HistoryDatabase(this.config.history.size,this.config.debug),this.images=new ImageEditorView(this),this.canvas=new ImageEditorView(this),this.controlsHelper=new ControlsHelperView(this.config),this.container.appendChild(await this.menu.render()),this.container.appendChild(await this.sidebar.render()),this.container.appendChild(await this.images.render()),this.container.appendChild(await this.canvas.render()),this.container.appendChild(await this.windows.render()),this.container.appendChild(await this.notifications.render()),this.container.appendChild(await this.controlsHelper.render()),this.config.debug&&console.log("Starting animations."),await this.startAnimations(),this.config.debug&&console.log("Registering dynamic inputs."),await this.registerDynamicInputs(),this.config.debug&&console.log("Registering download controllers."),await this.registerDownloadsControllers(),this.config.debug&&console.log("Registering animation controllers."),await this.registerAnimationsControllers(),this.config.debug&&console.log("Registering model controllers."),await this.registerModelControllers(),this.config.debug&&console.log("Registering invocation controllers."),await this.registerInvocationControllers(),this.config.debug&&console.log("Registering sample controllers."),await this.registerSampleControllers(),this.config.debug&&console.log("Registering layer controllers."),await this.registerLayersControllers(),this.config.debug&&console.log("Registering prompt controllers."),await this.registerPromptControllers(),this.config.debug&&console.log("Registering menu controllers."),await this.registerMenuControllers(),this.config.debug&&console.log("Registering layout controllers."),await this.registerLayoutControllers(),this.config.debug&&console.log("Registering theme controllers."),await this.registerThemeControllers(),this.config.debug&&console.log("Registering sidebar controllers."),await this.registerSidebarControllers(),this.config.debug&&console.log("Starting autosave."),await this.startAutosave(),this.config.debug&&console.log("Starting announcement check."),await this.startAnnouncements(),this.config.debug&&console.log("Starting keepalive."),await this.startKeepalive(),this.config.debug&&console.log("Registering authentication."),await this.registerLogout(),window.onpopstate=e=>this.popState(e),document.addEventListener("dragover",(e=>this.onDragOver(e))),document.addEventListener("drop",(e=>this.onDrop(e))),document.addEventListener("paste",(e=>this.onPaste(e))),document.addEventListener("keyup",(e=>this.onKeyUp(e))),document.addEventListener("keydown",(e=>this.onKeyDown(e))),document.addEventListener("keypress",(e=>this.onKeyPress(e))),document.addEventListener("mousemove",(e=>this.onMouseMove(e))),document.addEventListener("mouseleave",(e=>this.onMouseLeave(e))),this.config.debug&&console.log("Application initialization complete."),this.publish("applicationReady"),this.container.classList.remove("loading"))}async startAnnouncements(){this.userIsAdmin&&!this.userIsSandboxed&&(this.announcements=new AnnouncementsController(this),await this.announcements.initialize())}startAnimations(){this.headerLogo=document.querySelector("header h1"),isEmpty(this.headerLogo)?console.warn("Can't find header logo, not binding animations."):this.animations=!0}async enableAnimations(){this.animations||(this.animations=!0,this.session.setItem("animations",!0),document.body.classList.remove("no-animations"),this.publish("animationsEnabled"))}async disableAnimations(){this.animations&&(this.animations=!1,this.session.setItem("animations",!1),document.body.classList.add("no-animations"),this.publish("animationsDisabled"))}async setTheme(e){for(let t in e)window.document.documentElement.style.setProperty(`--${snakeCase(t)}`,e[t])}registerDynamicModelInput(e,t,i=null){e.defaultOptions=async()=>(await this.model.get(t)).reduce(((e,t)=>(isEmpty(t.directory)||"."===t.directory?e[t.name]=t.name:e[t.name]=`<strong>${t.name}</strong><span class='note' style='margin-left: 2px'>(${t.directory})</note>`,e)),{}),isEmpty(i)||(e.showModelMetadata=async e=>{let t=new ModelMetadataView(this.config),o=(await this.windows.spawnWindow(`Metadata for ${e}`,t,this.constructor.metadataWindowWidth,this.constructor.metadataWindowHeight),await this.model.get(`${i}/${e}`));t.setMetadata(o)})}async registerDynamicInputs(){this.userIsAdmin||delete DefaultVaeInputView.defaultOptions.other,this.registerDynamicModelInput(CheckpointInputView,"/checkpoints","/checkpoints"),this.registerDynamicModelInput(LoraInputView,"/lora","/lora"),this.registerDynamicModelInput(LycorisInputView,"/lycoris","/lycoris"),this.registerDynamicModelInput(InversionInputView,"/inversions","/inversions"),this.registerDynamicModelInput(MotionModuleInputView,"/motion","/motion"),ModelPickerInputView.defaultOptions=async()=>(await this.model.get("/model-options")).reduce(((e,t)=>{let i=isEmpty(t.type)?"":"checkpoint"===t.type?"Checkpoint":"checkpoint+diffusers"===t.type?"Checkpoint + Diffusers":"diffusers"===t.type?"Diffusers":"Preconfigured Model";return isEmpty(t.directory)||"."===t.directory?e[`${t.type}/${t.name}`]=`<strong>${t.name}</strong><em>${i}</em>`:e[`${t.type}/${t.name}`]=`<strong>${t.name}</strong><span class='note' style='margin-left: 2px'>(${t.directory})</note></span><em>${i}</em>`,e}),{}),ModelPickerInputView.showModelMetadata=async e=>{let t=e.split("/")[1],i=new ModelMetadataView(this.config),o=(await this.windows.spawnWindow(`Metadata for ${t}`,i,this.constructor.metadataWindowWidth,this.constructor.metadataWindowHeight),await this.model.get(`/checkpoints/${t}`));i.setMetadata(o)}}async registerModelControllers(){this.modelManager=new ModelManagerController(this),await this.modelManager.initialize(),this.modelPicker=new ModelPickerController(this),await this.modelPicker.initialize()}async registerDownloadsControllers(){this.downloads=new DownloadsController(this),await this.downloads.initialize()}async registerInvocationControllers(){this.engine=new InvocationController(this),await this.engine.initialize()}async registerSampleControllers(){this.samples=new SamplesController(this),await this.samples.initialize()}async registerLayersControllers(){this.layers=new LayersController(this),await this.layers.initialize()}async registerPromptControllers(){this.prompts=new PromptTravelController(this),await this.prompts.initialize()}async registerAnimationsControllers(){this.animation=new AnimationsController(this),await this.animation.initialize()}async registerLayoutControllers(){this.layout=new LayoutController(this),await this.layout.initialize()}async registerThemeControllers(){this.theme=new ThemeController(this),await this.theme.initialize()}get userIsAdmin(){return!isEmpty(window.enfugue)&&!0===window.enfugue.admin}get userIsSandboxed(){return!isEmpty(window.enfugue)&&!0===window.enfugue.sandboxed}getMenuCategories(){let e={...this.constructor.menuCategories};return this.userIsAdmin&&(e={...e,...this.constructor.adminMenuCategories},this.userIsSandboxed&&delete e.system),e.layout="Layout",e.theme="Theme",e.extras="Extras",e.help="Help",e}async registerMenuControllers(){let e=this.getMenuCategories();this.menuControllers={};for(let t in e){let i=e[t],o=this.constructor.menuCategoryShortcuts[t];this.menuControllers[t]=[];try{let e=await this.menu.addCategory(i,o);if(-1!==["theme","layout"].indexOf(t))continue;let s=await import(`../controller/${t}/index.autogenerated.mjs`);for(let i of s.Index)try{let o=(await import(`../controller/${t}/${i}`)).MenuController;if(isEmpty(o))throw"Module does not provide a 'MenuController' export.";if(!o.isDisabled()){let i=await e.addItem(o.menuName,o.menuIcon,o.menuShortcut),s=new o(this);await s.initialize(),i.onClick((()=>s.onClick())),this.menuControllers[t].push(s)}}catch(e){console.warn("Couldn't import",t,"menu controller",i,e)}}catch(e){console.warn("Couldn't register controllers for menu",t,e)}}}async registerSidebarControllers(){let e=await import("../controller/sidebar/index.autogenerated.mjs");this.sidebarControllers=[];for(let t of e.Index){let e=(await import(`../controller/sidebar/${t}`)).SidebarController;if(isEmpty(e))throw"Module does not provide a 'SidebarController' export.";let i=new e(this);await i.initialize(),this.sidebarControllers.push(i)}}async startKeepalive(){const e=this.config.model.status.interval||1e4,t=e=>{"ready"===e?this.publish("engineReady"):"busy"===e?this.publish("engineBusy"):"idle"===e?this.publish("engineIdle"):console.warn("Unknown status",e)};let i=document.querySelector("header");if(isEmpty(i))return void console.warn("No header found on page, not appending status view.");let o=await this.model.get(),s=new StatusView(this.config,o),n=await s.getNode();!isEmpty(o.system)&&!isEmpty(o.system.downloads)&&o.system.downloads.active>0&&this.downloads.checkStartTimer(),t(o.status),i.appendChild(n.render()),setInterval((async()=>{try{let e=await this.model.get();o.status!==e.status&&t(e.status),!isEmpty(o.system)&&!isEmpty(o.system.downloads)&&o.system.downloads.active>0&&this.downloads.checkStartTimer(),s.updateStatus(e),o=e}catch{s.updateStatus("error")}}),e);let a=await this.model.get("/invocation"),r=null;for(let e of a)if("processing"===e.status){r=e;break}isEmpty(r)||(isEmpty(r)||isEmpty(r.metadata)||isEmpty(r.metadata.tensorrt_build)?(this.notifications.push("info","Active Invocation Found","You have an image currently being generated, beginning monitoring process."),this.engine.canvasInvocation(r.uuid,r.animation)):this.notifications.push("info","TensorRT Build in Progress",`You have a TensorRT engine build in progress for ${r.metadata.tensorrt_build.model}. You'll receive a notification in this window when it is complete. The engine will remain unavailable until that time.`),this.publish("invocationBegin",r)),setInterval((async()=>{try{let e,t=await this.model.get("/invocation");for(let i of t)"processing"===i.status&&(null!==r&&r.id===i.id||(e=i)),isEmpty(r)||i.id!==r.id||i.status===r.status||("completed"===i.status?this.publish("invocationComplete",i):this.publish("invocationError",i),r=null);isEmpty(e)||(this.publish("invocationBegin",e),r=e)}catch(e){console.error(e)}}),e)}async registerLogout(){if(!isEmpty(window.enfugue.user)&&"noauth"!==window.enfugue.user){let e=new LogoutButtonView(this.config);document.querySelector("header").appendChild((await e.getNode()).render())}}async startAutosave(){try{let e=await this.history.getCurrentState();if(!isEmpty(e)&&(this.config.debug&&console.log("Loading autosaved state",e),await this.setState(e),this.notifications.push("info","Session Restored","Your last autosaved session was successfully loaded."),!isEmpty(this.canvas.node))){let e=this.canvas.node.find("enfugue-node-editor-zoom-reset");isEmpty(e)||e.trigger("click")}const t=this.config.model.autosave.interval||3e4;setInterval((()=>this.autosave()),t)}catch(e){console.error(e),this.notifications.push("warn","History Disabled","Couldn't open IndexedDB, history and autosave are disabled.")}}async autosave(e=!0){try{await this.history.setCurrentState(this.getState()),e&&SimpleNotification.notify("Session autosaved!",2e3)}catch(e){console.error("Couldn't autosave",e)}}subscribe(e,t){this.publisher.subscribe(e,t)}unsubscribe(e,t){this.publisher.unsubscribe(e,t)}async publish(e,t=null){this.publisher.publish(e,t)}spawnConfirmForm(e,t,i,o=!0,s=!1){return new Promise((async(n,a)=>{let r,l=!1,m=new e(this.config,i);m.onSubmit((()=>{l=!0,n(!0),o&&r.remove()})),m.onCancel((()=>{l=!0,n(!1),r.remove()})),r=await this.windows.spawnWindow(t,m,this.constructor.confirmViewWidth,this.constructor.confirmViewHeight),r.onClose((()=>{!l&&s?a():n(!1),l=!0}))}))}spawnVideoPlayer(e,t="Video"){return new Promise((async(i,o)=>{let s=new VideoPlayerView(this.config,e);await s.waitForLoad(),i(await this.windows.spawnWindow(t,s,s.width+4,s.height+34))}))}confirm(e,t=!0){return this.spawnConfirmForm(ConfirmFormView,"Confirm",e,t)}yesNo(e,t=!0){return this.spawnConfirmForm(YesNoFormView,"Yes or No",e,t,!0)}async saveAs(e,t,i,o){let s=new Blob([t],{type:i});return this.saveBlobAs(e,s,o)}async saveRemoteAs(e,t){let i=t.split("/").slice(-1)[0].split(".")[1];return this.saveBlobAs(e,await downloadAsBlob(t),i)}async saveBlobAs(e,t,i){i.startsWith(".")||(i=`.${i}`);let o=window.URL.createObjectURL(t),s=new FileNameFormView(this.config),n=await this.windows.spawnWindow(e,s,this.constructor.filenameFormInputWidth,this.constructor.filenameFormInputHeight);s.onCancel((()=>n.close())),s.onSubmit((e=>{let t=e.filename;t.endsWith(i)&&(t=t.substring(0,t.length-i.length));let s=document.createElement("a");s.setAttribute("download",`${t}${i}`),s.href=o,document.body.appendChild(s),window.requestAnimationFrame((()=>{s.dispatchEvent(createEvent("click")),document.body.removeChild(s),n.remove()}))})),n.onClose((()=>window.URL.revokeObjectURL(o)))}async onPaste(e){let t=(e.clipboardData||e.originalEvent.clipboardData).items;for(let e of t)"file"===e.kind?this.loadFile(e.getAsFile()):e.getAsString((e=>this.onTextPaste(e)))}getStateFromMetadata(e){return isEmpty(e.EnfugueUIState)?{}:JSON.parse(e.EnfugueUIState)}async loadFile(e,t="Image"){let i=new FileReader;i.addEventListener("load",(async()=>{let e,t=i.result.substring(5,i.result.indexOf(";")),o=t.length+13;switch(t){case"application/json":await this.setState(JSON.parse(atob(i.result.substring(o)))),this.notifications.push("info","Generation Settings Loaded","Image generation settings were successfully retrieved from image metadata.");break;case"image/png":e=new BackgroundImageView(this.config,i.result),await e.waitForLoad();let s=this.getStateFromMetadata(e.metadata);if(!isEmpty(s)&&await this.yesNo("It looks like this image was made with Enfugue. Would you like to load the identified generation settings?"))return await this.setState(s),void this.notifications.push("info","Generation Settings Loaded","Image generation settings were successfully retrieved from image metadata.");case"image/gif":case"image/avif":case"image/jpeg":case"image/bmp":case"image/tiff":case"image/x-icon":case"image/webp":isEmpty(e)&&(e=new BackgroundImageView(this.config,i.result,!1)),this.layout.checkHideSamples(!1),this.layers.addImageLayer(e);break;case"video/mp4":case"video/webm":case"video/m4v":case"video/mkv":case"video/x-msvideo":case"video/x-ms-wmv":case"video/quicktime":this.layout.checkHideSamples(!1),this.layers.addVideoLayer(i.result);break;default:this.notifications.push("warn","Unhandled File Type",`File type "${t}" is not handled by Enfugue.`)}})),i.readAsDataURL(e)}async onTextPaste(e){e.startsWith("<html>")}getStatefulControllers(){let e=[this.modelPicker,this.layers,this.samples,this.prompts].concat(this.sidebarControllers);for(let t in this.menuControllers)e=e.concat(this.menuControllers[t]);return e}getState(e=!0){let t={},i=this.getStatefulControllers();for(let o of i)t={...t,...o.getState(e)};return t}shouldSaveState(){let e=this.getState();return!(isEmpty(e.prompts)||isEmpty(e.prompts.prompt)&&isEmpty(e.prompts.negativePrompt))||!isEmpty(e.layers)}async setState(e,t=!1){!0===t&&this.shouldSaveState()&&(await this.autosave(!1),await this.history.flush(e));let i=this.getStatefulControllers();isEmpty(e.canvas)||this.canvas.setDimension(e.canvas.width,e.canvas.height);for(let t of i)await t.setState(e)}async resetState(e=!0){let t={layers:[]},i=this.getStatefulControllers();for(let e of i)t={...t,...e.getDefaultState()};await this.setState(t,e),this.canvas.resetCanvasPosition(),this.publish("reInitializeModel")}async initializeStateFromImage(e,t=!0,i=!0,o=null,s=!1){try{let n,a={},r=this.getStatefulControllers();null===i&&(i=!0);for(let e of r)a=i?{...a,...e.getState()}:{...a,...e.getDefaultState()};if(a.layers=[],!isEmpty(o))for(let e in o)void 0!==a[e]&&(null===o[e]?a[e]=null:"object"==typeof a[e]&&"object"==typeof o[e]?a[e]={...a[e],...o[e]}:a[e]=o[e]);this.layout.checkHideSamples(!1),await sleep(1),await this.setState(a,t),await sleep(1),n=s?await this.layers.addVideoLayer(e):await this.layers.addImageLayer(e),await sleep(1),await n.editorNode.scaleCanvasToSize()}catch(e){console.error(e)}}invoke(e){return e.state=this.getState(!1),this.engine.invoke(e)}onKeyPress(e){e.shiftKey&&(this.menu.fireCategoryShortcut(e.key),this.publish("keyboardShortcut",e.key))}getCanvasUnderMouse(e=!1){for(let t of[this.images,this.canvas])if(!isEmpty(t.node)){let i=t.node.find("enfugue-node-canvas");if(!isEmpty(i)&&!isEmpty(i.element)&&i.element.checkVisibility()){let o=i.element.getBoundingClientRect(),s=t.node.element.getBoundingClientRect();if(o.x<this.mouseX&&this.mouseX<o.x+o.width&&o.y<this.mouseY&&this.mouseY<o.y+o.height&&s.x<this.mouseX&&this.mouseX<s.x+s.width&&s.y<this.mouseY&&this.mouseY<s.y+s.height)return e?t:i}}}onKeyDown(e){if("Shift"===e.key&&this.menu.addClass("highlight"),"Space"===e.code){let e=this.getCanvasUnderMouse(),t=new MouseEvent("mousedown",{clientX:this.mouseX,clientY:this.mouseY,button:1});e.trigger(t)}}onKeyUp(e){if("Shift"===e.key&&this.menu.removeClass("highlight"),"Space"===e.code){let e=this.getCanvasUnderMouse(),t=new MouseEvent("mouseup",{clientX:this.mouseX,clientY:this.mouseY,button:1});e.trigger(t)}}onMouseLeave(e){}onMouseMove(e){if(this.mouseX=e.clientX,this.mouseY=e.clientY,!1===this.animations)return;let[t,i]=[e.clientX/window.innerWidth,e.clientY/window.innerHeight],o=[];for(let e=0;e<this.constructor.logoShadowSteps;e++){let[s,n]=[t*(e+1)*this.constructor.logoShadowOffset,i*(e+1)*this.constructor.logoShadowOffset],a=this.constructor.logoShadowOpacity-e/this.constructor.logoShadowSteps*this.constructor.logoShadowOpacity,r=`rgba(${this.constructor.logoShadowRGB.concat(a.toFixed(2)).join(",")})`;o.push(`${s}px ${n}px ${this.constructor.logoShadowSpread}px ${r}`)}this.headerLogo.style.textShadow=o.join(",")}onDragOver(e){e.preventDefault()}onDrop(e){e.preventDefault(),e.stopPropagation();try{this.loadFile(e.dataTransfer.files[0])}catch(e){console.warn(e)}}async popState(e){}}export{Application};
