import{isEmpty,promptFiles,truncate}from"../../base/helpers.mjs";import{ElementBuilder}from"../../base/builder.mjs";import{Controller}from"../base.mjs";import{View}from"../../view/base.mjs";import{ImageView}from"../../view/image.mjs";import{ToolbarView}from"../../view/menu.mjs";import{ImageEditorScribbleNodeOptionsFormView,ImageEditorPromptNodeOptionsFormView,ImageEditorImageNodeOptionsFormView,ImageEditorVideoNodeOptionsFormView}from"../../forms/enfugue/image-editor.mjs";const E=new ElementBuilder;class LayerOptionsView extends View{static tagName="enfugue-layer-options-view";static placeholderText="No options available. When you select a layer with options, they will appear in this pane.";async setForm(e){this.node.content(await e.getNode())}async resetForm(){this.node.content(E.div().class("placeholder").content(this.constructor.placeholderText))}async build(){let e=await super.build();return e.content(E.div().class("placeholder").content(this.constructor.placeholderText)),e}}class LayersView extends View{static tagName="enfugue-layers-view";static placeholderText="No layers yet. Use the buttons above to add layers, drag and drop videos or images onto the canvas, or paste media from your clipboard.";constructor(e){super(e),this.toolbar=new ToolbarView(e)}async emptyLayers(){this.node.find(".layers").empty(),this.node.find(".placeholder").show()}async addLayer(e,t=!1){let i=this.node.find(".layers"),a=this.node.find(".placeholder");t&&(i.empty(),this.node.render()),i.append(await e.getNode()),a.hide(),this.node.render()}async build(){let e=await super.build();return e.content(await this.toolbar.getNode(),E.div().class("placeholder").content(this.constructor.placeholderText),E.div().class("layers")),e.on("drop",(e=>{e.preventDefault(),e.stopPropagation()})),e}}class LayerView extends View{static previewWidth=30;static previewHeight=30;static tagName="enfugue-layer-view";constructor(e,t,i){super(e.config),this.controller=e,this.editorNode=t,this.form=i,this.isActive=!1,this.isVisible=!0,this.isLocked=!1,this.previewImage=new ImageView(e.config,null,!1),this.editorNode.onResize((()=>this.resized())),this.getLayerImage().then((e=>this.previewImage.setImage(e))),this.form.onSubmit((()=>{this.debounceDrawPreviewImage()})),this.subtitle=null}get foregroundStyle(){return window.getComputedStyle(document.documentElement).getPropertyValue("--theme-color-primary")}async getLayerImage(){let e=this.controller.canvas.width,t=this.controller.canvas.height,i=Math.max(e,t),a=this.constructor.previewWidth/i,s=e/i,r=t/i,o=this.constructor.previewWidth*s,l=this.constructor.previewHeight*r,n=this.editorNode.getState(!0),d=n.x*a,h=n.y*a,c=n.w*a,m=n.h*a,y=document.createElement("canvas");this.lastCanvasWidth=e,this.lastCanvasHeight=t,this.lastNodeWidth=n.w,this.lastNodeHeight=n.h,this.lastNodeX=n.x,this.lastNodeY=n.y,y.width=o,y.height=l;let g=y.getContext("2d");if(n.src){let e=n.src;if(e.startsWith("data:video")||e.endsWith("mp4")||e.endsWith("webp")||e.endsWith("avi")||e.endsWith("mov")){let t=document.createElement("canvas");t.width=this.editorNode.content.video.videoWidth,t.height=this.editorNode.content.video.videoHeight,t.getContext("2d").drawImage(this.editorNode.content.video,0,0),e=t.toDataURL()}let t=new ImageView(this.config,e);await t.waitForLoad();let i=0,s=0,r=t.width*a,o=t.height*a,l=isEmpty(n.anchor)?null:n.anchor.split("-");if("cover"===n.fit||"contain"===n.fit){let e=c/t.width,a=m/t.height;if("cover"===n.fit){let n=Math.ceil(t.width*e),d=Math.ceil(t.height*e),h=Math.ceil(t.width*a),y=Math.ceil(t.height*a);if(c<=n&&m<=d){if(r=n,o=d,!isEmpty(l))switch(l[0]){case"center":i=Math.floor(m/2-o/2);break;case"bottom":i=m-o}}else if(c<=h&&m<=y&&(r=h,o=y,!isEmpty(l)))switch(l[1]){case"center":s=Math.floor(c/2-r/2);break;case"right":s=c-r}}else{let n=Math.floor(t.width*e),d=Math.floor(t.height*e),h=Math.floor(t.width*a),y=Math.floor(t.height*a);if(c>=n&&m>=d){if(r=n,o=d,!isEmpty(l))switch(l[0]){case"center":i=Math.floor(m/2-o/2);break;case"bottom":i=m-o}}else if(c>=h&&m>=y&&(r=h,o=y,!isEmpty(l)))switch(l[1]){case"center":s=Math.floor(c/2-r/2);break;case"right":s=c-r}}}else if("stretch"===n.fit)r=c,o=m;else if(!isEmpty(l)){switch(l[0]){case"center":i=Math.floor(m/2-o/2);break;case"bottom":i=m-o}switch(l[1]){case"center":s=Math.floor(c/2-r/2);break;case"right":s=c-r}}g.beginPath(),g.rect(d,h,c,m),g.clip(),g.drawImage(t.image,d+s,h+i,r,o)}else g.fillStyle=this.foregroundStyle,g.fillRect(d,h,c,m);return y.toDataURL()}async resized(){let e=this.controller.canvas.width,t=this.controller.canvas.height,i=this.editorNode.getState();e===this.lastCanvasWidth&&t===this.lastCanvasHeight&&i.w===this.lastNodeWidth&&i.h===this.lastNodeHeight&&i.x===this.lastNodeX&&i.y===this.lastNodeY||this.debounceDrawPreviewImage()}async drawPreviewImage(){this.previewImage.setImage(await this.getLayerImage())}debounceDrawPreviewImage(){clearTimeout(this.drawPreviewTimeout),this.drawPreviewTimeout=setTimeout((()=>{this.drawPreviewImage()}),500)}async remove(){this.controller.removeLayer(this)}async setActive(e){this.isActive=e,this.isActive?this.addClass("active"):this.removeClass("active")}async setVisible(e){if(this.isVisible=e,!isEmpty(this.hideShowLayer)){let e=this.isVisible?"fa-solid fa-eye":"fa-solid fa-eye-slash";this.hideShowLayer.setIcon(e)}this.isVisible?this.editorNode.show():this.editorNode.hide()}async setLocked(e){if(this.isLocked=e,!isEmpty(this.lockUnlockLayer)){let e=this.isLocked?"fa-solid fa-lock":"fa-solid fa-lock-open";this.lockUnlockLayer.setIcon(e)}this.isLocked?this.editorNode.addClass("locked"):this.editorNode.removeClass("locked")}getState(e=!0){return{...this.editorNode.getState(e),...this.form.values,isLocked:this.isLocked,isActive:this.isActive,isVisible:this.isVisible}}async setState(e){await this.editorNode.setState(e),await this.form.setValues(e)}async setName(e){void 0!==this.node&&this.node.find("span.name").content(e)}async setSubtitle(e){if(this.subtitle=e,void 0!==this.node){let t=this.node.find("span.subtitle");isEmpty(e)?t.empty().hide():t.content(e).show()}}async build(){let e=await super.build();this.toolbar=new ToolbarView(this.config);let t=this.isVisible?"Hide Layer":"Show Layer",i=this.isVisible?"fa-solid fa-eye":"fa-solid fa-eye-slash";this.hideShowLayer=await this.toolbar.addItem(t,i);this.isLocked,this.isLocked;this.lockUnlockLayer=await this.toolbar.addItem("Lock Layer","fa-solid fa-lock-open"),this.hideShowLayer.onClick((()=>this.setVisible(!this.isVisible))),this.lockUnlockLayer.onClick((()=>this.setLocked(!this.isLocked)));let a=E.span().class("name").content(this.editorNode.name),s=E.span().class("subtitle");return isEmpty(this.subtitle)?s.hide():s.content(this.subtitle),e.content(await this.hideShowLayer.getNode(),await this.lockUnlockLayer.getNode(),E.div().class("title").content(a,s),await this.previewImage.getNode(),E.button().content("&times;").class("close").on("click",(()=>this.remove()))).attr("draggable","true").on("dragstart",(e=>{e.dataTransfer.effectAllowed="move",this.controller.draggedLayer=this,this.addClass("dragging")})).on("dragleave",(e=>{this.removeClass("drag-target-below").removeClass("drag-target-above"),this.controller.dragTarget===this&&(this.controller.dragTarget=null)})).on("dragover",(e=>{if(this.controller.draggedLayer!==this){let t=e.layerY>e.target.getBoundingClientRect().height/2;t?this.removeClass("drag-target-above").addClass("drag-target-below"):this.addClass("drag-target-above").removeClass("drag-target-below"),this.controller.dragTarget=this,this.controller.dropBelow=t}})).on("dragend",(e=>{this.controller.dragEnd(),this.removeClass("dragging").removeClass("drag-target-below").removeClass("drag-target-above"),e.preventDefault(),e.stopPropagation()})).on("click",(e=>{this.controller.activate(this)})).on("drop",(e=>{e.preventDefault(),e.stopPropagation()})),e}}class LayersController extends Controller{removeLayer(e,t=!0){t&&e.editorNode.remove(!1);let i=this.layers.indexOf(e);-1!==i?(this.layers=this.layers.slice(0,i).concat(this.layers.slice(i+1)),0===this.layers.length?(this.layersView.emptyLayers(),this.layerOptions.resetForm()):this.layersView.node.find(".layers").remove(e.node.element),e.isActive&&this.layerOptions.resetForm(),this.layersChanged()):console.error("Couldn't find",e)}dragEnd(){if(!isEmpty(this.draggedLayer)&&!isEmpty(this.dragTarget)&&this.draggedLayer!==this.dragTarget){this.draggedLayer.removeClass("dragging"),this.dragTarget.removeClass("drag-target-above").removeClass("drag-target-below");let e=this.layers.indexOf(this.draggedLayer),t=this.layers.indexOf(this.dragTarget);if(t>e&&t--,this.dropBelow||t++,t!==e){this.canvas.reorderNode(t,this.draggedLayer.editorNode),this.layers=this.layers.filter((e=>e!==this.draggedLayer)),this.layers.splice(t,0,this.draggedLayer);let e=this.layersView.node.find(".layers");e.remove(this.draggedLayer.node),e.insert(t,this.draggedLayer.node),e.render(),this.layersChanged()}}this.draggedLayer=null,this.dragTarget=null}getState(e=!0){return{layers:this.layers.map((t=>t.getState(e)))}}getDefaultState(){return{layers:[]}}getLayerName(e){let t=1,i=e;for(;-1!==this.layers.map((e=>e.name)).indexOf(i);)i=`${e} (${++t})`;return i}async setState(e){if(this.emptyLayers(),!isEmpty(e.layers)){for(let t of e.layers)await this.addLayerByState(t);this.activateLayer(this.layers.length-1)}}async addLayerByState(e,t=null){let i;switch(e.classname){case"ImageEditorPromptNodeView":(isEmpty(e.name)||e.name===e.classname)&&(e.name=this.getLayerName("Prompt")),i=await this.addPromptLayer(!1,t,e.name);break;case"ImageEditorScribbleNodeView":(isEmpty(e.name)||e.name===e.classname)&&(e.name=this.getLayerName("Scribble")),i=await this.addScribbleLayer(!1,t,e.name);break;case"ImageEditorImageNodeView":(isEmpty(e.name)||e.name===e.classname)&&(e.name=this.getLayerName("Image")),i=await this.addImageLayer(e.src,!1,t,e.name);break;case"ImageEditorVideoNodeView":(isEmpty(e.name)||e.name===e.classname)&&(e.name=this.getLayerName("Video")),i=await this.addVideoLayer(e.src,!1,t,e.name);break;default:console.error(`Unknown layer class ${e.classname}, skipping and dumping layer data.`),console.log(e),console.log(t)}return isEmpty(i)||await i.setState(e),i}async emptyLayers(){for(let e of this.layers)this.canvas.removeNode(e.editorNode);this.layers=[],this.layersView.emptyLayers(),this.layerOptions.resetForm(),this.layersChanged()}async activateLayer(e){if(-1!==e){for(let t=0;t<this.layers.length;t++)this.layers[t].setActive(t===e);this.layerOptions.setForm(this.layers[e].form)}}activate(e){return this.activateLayer(this.layers.indexOf(e))}async addLayer(e,t=!0){e.editorNode.onNameChange((t=>{e.setName(t,!1)})),e.editorNode.onClose((()=>{this.removeLayer(e,!1)})),e.form.onSubmit((()=>{this.layersChanged()})),this.layers.push(e),await this.layersView.addLayer(e,1===this.layers.length),t&&this.activateLayer(this.layers.length-1),this.layersChanged()}async addVideoLayer(e,t=!0,i=null,a="Video"){isEmpty(i)&&(i=await this.canvas.addVideoNode(e,a));let s=new ImageEditorVideoNodeOptionsFormView(this.config),r=new LayerView(this,i,s);return s.onSubmit((e=>{let t=[];if("denoised"===e.visibility?t.push("Video to Video"):"visible"===e.visibility&&t.push("Visible"),e.imagePrompt&&t.push("IP Adapter"),e.control&&!isEmpty(e.controlnetUnits)){let i=e.controlnetUnits.map((e=>isEmpty(e.controlnet)?"canny":e.controlnet)),a=i.filter(((e,t)=>i.indexOf(e)===t));t.push(`ControlNet (${a.join(", ")})`)}let a=t.join(", ");i.updateOptions(e),r.setSubtitle(a)})),await this.addLayer(r,t),r}async addImageLayer(e,t=!0,i=null,a="Image"){e instanceof ImageView&&(e=e.src),isEmpty(i)&&(i=await this.canvas.addImageNode(e,a));let s=new ImageEditorImageNodeOptionsFormView(this.config),r=new LayerView(this,i,s);return s.onSubmit((e=>{let t=[];if("denoised"===e.visibility?t.push("Image to Image"):"visible"===e.visibility&&t.push("Visible"),e.imagePrompt&&t.push("IP Adapter"),e.control&&!isEmpty(e.controlnetUnits)){let i=e.controlnetUnits.map((e=>isEmpty(e.controlnet)?"canny":e.controlnet)),a=i.filter(((e,t)=>i.indexOf(e)===t));t.push(`ControlNet (${a.join(", ")})`)}let a=t.join(", ");i.updateOptions(e),r.setSubtitle(a)})),await this.addLayer(r,t),r}async addScribbleLayer(e=!0,t=null,i="Scribble"){isEmpty(t)&&(t=await this.canvas.addScribbleNode(i));let a=new ImageEditorScribbleNodeOptionsFormView(this.config),s=new LayerView(this,t,a);return t.content.onDraw((()=>{this.activate(s),s.debounceDrawPreviewImage(),this.layersChanged()})),await this.addLayer(s,e),s}async addPromptLayer(e=!0,t=null,i="Prompt"){isEmpty(t)&&(t=await this.canvas.addPromptNode(i));let a=new ImageEditorPromptNodeOptionsFormView(this.config),s=new LayerView(this,t,a);return a.onSubmit((e=>{t.setPrompts(e.prompt,e.negativePrompt)})),await this.addLayer(s,e),s}async promptAddImageLayer(){let e;try{e=await promptFiles()}catch(e){}isEmpty(e)||this.application.loadFile(e,truncate(e.name,16))}getLayerByEditorNode(e){return this.layers.filter((t=>t.editorNode===e)).shift()}async addCopiedNode(e,t){let i=this.getLayerByEditorNode(t).getState(),a=e.getState();await this.addLayerByState({...i,...a},e),this.activateLayer(this.layers.length-1)}async layersChanged(){this.publish("layersChanged",this.getState().layers)}async initialize(){this.layers=[],this.layerOptions=new LayerOptionsView(this.config),this.layersView=new LayersView(this.config);let e=await this.layersView.toolbar.addItem("Image/Video","fa-regular fa-image"),t=await this.layersView.toolbar.addItem("Draw Scribble","fa-solid fa-pencil");e.onClick((()=>this.promptAddImageLayer())),t.onClick((()=>this.addScribbleLayer())),this.application.container.appendChild(await this.layerOptions.render()),this.application.container.appendChild(await this.layersView.render()),this.canvas.onNodeFocus((e=>{this.activate(this.getLayerByEditorNode(e))})),this.canvas.onNodeCopy(((e,t)=>{this.addCopiedNode(e,t)})),this.canvas.onNodePlace((()=>{this.layersChanged()}))}}export{LayersController};
