import{View}from"./base.mjs";import{waitFor,isEmpty}from"../base/helpers.mjs";import{ElementBuilder}from"../base/builder.mjs";import{PNG}from"../base/png.mjs";const E=new ElementBuilder({imageDetails:"enfugue-image-details",imageBrowser:"enfugue-image-browser"});class ImageView extends View{static tagName="img";static positionProperty="object-position";constructor(t,i,e){if(super(t),this.src=i,this.usePng=e,this.loadedCallbacks=[],this.metadata={},!isEmpty(i)){if(null==e)if(i.startsWith("data")){e="image/png"===i.substring(5,i.indexOf(";"))}else e=i.endsWith(".png");if(e){let t=PNG.fromURL;i instanceof File?t=PNG.fromFile:i instanceof Image&&(i=i.src),t.call(PNG,i).then((t=>{this.png=t,this.metadata={...this.metadata,...t.metadata},this.src=t.base64,this.image=new Image,this.image.onload=()=>this.imageLoaded(),this.image.src=this.src})).catch((t=>{console.error(t),this.loaded=!0,this.error=!0}))}else this.image=new Image,this.image.onload=()=>this.imageLoaded(),this.image.src=this.src}}setImage(t){if(this.src!==t)if(this.loaded=!1,this.usePng){let i=PNG.fromURL;t instanceof File?i=PNG.fromFile:t instanceof Image&&(t=t.src),i.call(PNG,t).then((t=>{this.png=t,this.metadata={...this.metadata,...t.metadata},t.addMetadata(this.metadata),this.src=t.base64,this.image=new Image,this.image.onload=()=>this.imageLoaded(),this.image.src=this.src})).catch((t=>{console.error(t),this.loaded=!0,this.error=!0}))}else this.src=t,this.image=new Image,this.image.onload=()=>this.imageLoaded(),this.image.src=t}onLoad(t){this.loaded?t(this):this.loadedCallbacks.push(t)}waitForLoad(){return waitFor((()=>this.loaded))}imageLoaded(){this.loaded=!0,this.width=this.image.width,this.height=this.image.height;for(let t of this.loadedCallbacks)t(this);this.loadedCallbacks=[],void 0!==this.node&&this.node.src(this.src)}getDataURL(){let t=document.createElement("canvas");return t.width=this.width,t.height=this.height,t.getContext("2d").drawImage(this.image,0,0),t.toDataURL()}async getImageAsDataURL(){return this.src.startsWith("data")||(this.setImage(this.getDataURL()),await this.waitForLoad()),this.image}async getBlob(){return await this.waitForLoad(),this.png.blob}async downscale(t=2){await this.waitForLoad();let i=document.createElement("canvas");i.width=Math.floor(this.width/t),i.height=Math.floor(this.height/t),i.getContext("2d").drawImage(this.image,0,0,i.width,i.height),this.setImage(i.toDataURL()),await this.waitForLoad()}async mirrorHorizontally(){await this.waitForLoad();let t=document.createElement("canvas");t.width=this.width,t.height=this.height;let i=t.getContext("2d");i.translate(this.width,0),i.scale(-1,1),i.drawImage(this.image,0,0),this.setImage(t.toDataURL()),await this.waitForLoad()}async mirrorVertically(){await this.waitForLoad();let t=document.createElement("canvas");t.width=this.width,t.height=this.height;let i=t.getContext("2d");i.translate(0,this.height),i.scale(1,-1),i.drawImage(this.image,0,0),this.setImage(t.toDataURL()),await this.waitForLoad()}async rotateClockwise(){await this.waitForLoad();let t=document.createElement("canvas");t.width=this.height,t.height=this.width;let i=t.getContext("2d");i.translate(this.height,0),i.rotate(Math.PI/2),i.drawImage(this.image,0,0),this.setImage(t.toDataURL()),await this.waitForLoad()}async rotateCounterClockwise(){await this.waitForLoad();let t=document.createElement("canvas");t.width=this.height,t.height=this.width;let i=t.getContext("2d");i.translate(0,this.width),i.rotate(3*Math.PI/2),i.drawImage(this.image,0,0),this.setImage(t.toDataURL()),await this.waitForLoad()}setFit(t){this.fit=t;for(let i of["actual","stretch","cover","contain"]){let e=`fit-${i}`;i===t?this.addClass(e):this.removeClass(e)}}setAnchor(t,i,e){if(isEmpty(t))this.css(this.constructor.positionProperty,null);else{let[s,o]=t.split("-"),a="bottom"==s?100:"center"==s?50:0,h="right"==o?100:"center"==o?50:0,r={};r[this.constructor.positionProperty]=`calc(${h}% + ${i}px) calc(${a}% + ${e}px)`,this.css(r)}}async build(){let t=await super.build();return isEmpty(this.src)||t.attr("src",this.src),t}}class BackgroundImageView extends ImageView{static tagName="enfugue-background-image-view";static positionProperty="background-position";setImage(t){this.src!==t&&(this.loaded=!1,this.onLoad((()=>{void 0!==this.node&&this.node.find(".background").css("background-image",`url(${this.src})`)})),this.src=t,this.image=new Image,this.image.onload=()=>this.imageLoaded(),this.image.src=t)}async build(){let t=await super.build();if(!isEmpty(this.src)){let i=E.div().class("background").css("background-image",`url(${this.src})`);t.append(i)}return t}}class ImageInspectorView extends View{static tagName="enfugue-image-inspector";static loaderClassName="loading-bar";static scrollPixels=40;static scrollInterval=50;static scrollFactor=5;static imageBrowserHeight=100;static scrollGrowRate=.1;constructor(t,i,e,s,o){super(t),this.src=i,this.name=e,this.width=s,this.height=o,this.imageView=new ImageView(t,i),this.imageView.onLoad((()=>{if(void 0!==this.node){this.node.find(E.getCustomTag("imageDetails")).content(this.subtitle);let t=this.node.find(E.getCustomTag("imageBrowser"));this.imageView.width>this.width||this.imageView.height>this.height?t.show():t.hide()}}))}setDimension(t,i){if(this.width=t,this.height=i,void 0!==this.node&&(this.node.css({width:this.width,height:this.height}),this.imageView.loaded)){let t=this.node.find(E.getCustomTag("imageBrowser"));this.imageView.width>this.width||this.imageView.height>this.height?(this.updateIndicator(),t.show()):t.hide()}}setImage(t){this.src!==t&&(this.src=t,this.imageView.setImage(t))}get details(){return isEmpty(this.imageView.width)||isEmpty(this.imageView.height)?null:`${this.imageView.width}px × ${this.imageView.height}px`}waitForLoad(){return this.imageView.waitForLoad()}onBrowserMouseEnter(t){this.inBrowser=!0}onBrowserMouseLeave(t){this.inBrowser=!1,this.isBrowsing=!1}onBrowserMouseMove(t){this.isBrowsing&&(t.preventDefault(),t.stopPropagation(),this.checkMoveBrowser(t.offsetX,t.offsetY))}onBrowserMouseDown(t){this.isBrowsing=!0,t.preventDefault(),t.stopPropagation(),this.checkMoveBrowser(t.offsetX,t.offsetY)}onBrowserMouseUp(t){this.isBrowsing=!1}onNodeMouseEnter(t){this.checkMousePosition(t.offsetX-this.node.element.childNodes[0].scrollLeft,t.offsetY-this.node.element.childNodes[0].scrollTop)}onNodeMouseMove(t){this.checkMousePosition(t.offsetX-this.node.element.childNodes[0].scrollLeft,t.offsetY-this.node.element.childNodes[0].scrollTop)}onNodeMouseLeave(t){this.scrollX=0,this.scrollY=0,this.updateScrollNodes()}checkMousePosition(t,i){if(this.inBrowser)return this.scrollX=0,this.scrollY=0,void this.updateScrollNodes();t>this.width-this.constructor.scrollPixels?this.scrollX<1&&(this.scrollX=1):t<this.constructor.scrollPixels?this.scrollX>-1&&(this.scrollX=-1):this.scrollX=0,i>this.height-this.constructor.scrollPixels?this.scrollY<1&&(this.scrollY=1):i<this.constructor.scrollPixels?this.scrollY>-1&&(this.scrollY=-1):this.scrollY=0,this.updateScrollNodes(),this.checkStartScroll()}checkMoveBrowser(t,i){let e=t/this.imageBrowserWidth,s=i/this.imageBrowserHeight,o=e*this.imageView.width,a=s*this.imageView.height,h=0,r=0;o>this.width/2&&(h=o-this.width/2),a>this.height/2&&(r=a-this.height/2),this.node.element.childNodes[0].scrollLeft=h,this.node.element.childNodes[0].scrollTop=r,this.updateIndicator()}updateScrollNodes(){let t=this.node.find(".left"),i=this.node.find(".up"),e=this.node.find(".right"),s=this.node.find(".down");this.scrollX<0?t.addClass("active"):t.removeClass("active"),this.scrollX>0?e.addClass("active"):e.removeClass("active"),this.scrollY<0?i.addClass("active"):i.removeClass("active"),this.scrollY>0?s.addClass("active"):s.removeClass("active")}checkStartScroll(){if(isEmpty(this.scrollInterval)){let t,i;this.scrollInterval=setInterval((()=>{let e=!1;0!=this.scrollX&&(e=!0,this.scrollX===t&&(this.scrollX*=1+this.constructor.scrollGrowRate),this.node.element.childNodes[0].scrollLeft=this.node.element.childNodes[0].scrollLeft+this.scrollX*this.constructor.scrollFactor,t=this.scrollX),0!=this.scrollY&&(e=!0,this.scrollY===i&&(this.scrollY*=1+this.constructor.scrollGrowRate),this.node.element.childNodes[0].scrollTop=this.node.element.childNodes[0].scrollTop+this.scrollY*this.constructor.scrollFactor,i=this.scrollY),e?this.updateIndicator():(clearInterval(this.scrollInterval),this.scrollInterval=null)}),this.constructor.scrollInterval)}}get visibleHeightRatio(){return this.height/this.imageView.height}get visibleWidthRatio(){return this.width/this.imageView.width}get imageBrowserHeight(){return this.constructor.imageBrowserHeight}get imageBrowserWidth(){return this.imageView.width/(this.imageView.height/this.imageBrowserHeight)}get scrollLeftRatio(){return this.node.element.childNodes[0].scrollLeft/(this.imageView.width-this.width)}get scrollTopRatio(){return this.node.element.childNodes[0].scrollTop/(this.imageView.height-this.height)}get indicatorWidth(){return this.imageBrowserWidth*this.visibleWidthRatio}get indicatorHeight(){return this.imageBrowserHeight*this.visibleHeightRatio}get indicatorLeft(){return this.scrollLeftRatio*(this.imageBrowserWidth-this.indicatorWidth)}get indicatorTop(){return this.scrollTopRatio*(this.imageBrowserHeight-this.indicatorHeight)}updateIndicator(){this.node.find(E.getCustomTag("imageBrowser")).find("span").css({width:this.indicatorWidth,height:this.indicatorHeight,left:this.indicatorLeft,top:this.indicatorTop})}async build(){let t=await super.build(),i=E.imageDetails().content(),e=E.span(),s=E.imageBrowser().content(E.img().src(this.src),e).on("mouseenter",(t=>this.onBrowserMouseEnter(t))).on("mouseleave",(t=>this.onBrowserMouseLeave(t))).on("mousemove",(t=>this.onBrowserMouseMove(t))).on("mousedown",(t=>this.onBrowserMouseDown(t))).on("mouseup",(t=>this.onBrowserMouseUp(t))).on("dblclick",(t=>{t.preventDefault(),t.stopPropagation()}));if(this.imageView.loaded){let t=100,s=this.imageView.width/(this.imageView.height/100),o=this.height/this.imageView.height,a=s*(this.width/this.imageView.width),h=t*o;e.css({width:a,height:h}),i.content(this.subtitle)}else s.hide(),i.hide();return t.content(E.div().class("image-view-container").content(await this.imageView.getNode()),E.div().class("up").content(E.i().class("fa-solid fa-angle-up")),E.div().class("left").content(E.i().class("fa-solid fa-angle-left")),E.div().class("right").content(E.i().class("fa-solid fa-angle-right")),E.div().class("down").content(E.i().class("fa-solid fa-angle-down")),i,s).css({width:this.width,height:this.height}).on("mouseenter",(t=>this.onNodeMouseEnter(t))).on("mousemove",(t=>this.onNodeMouseMove(t))).on("mouseleave",(t=>this.onNodeMouseLeave(t))),t}}export{ImageView,BackgroundImageView,ImageInspectorView};
