import{isEmpty,isEquivalent,bindMouseUntilRelease}from"../../base/helpers.mjs";import{View}from"../base.mjs";import{ImageView}from"../image.mjs";import{ElementBuilder}from"../../base/builder.mjs";import{NumberInputView}from"../../forms/input.mjs";const E=new ElementBuilder;class SampleChooserView extends View{static tagName="enfugue-sample-chooser";static loopIcon="fa-solid fa-rotate-left";static loopTooltip="Loop the video, restarting it after it has completed.";static playIcon="fa-solid fa-play";static playTooltip="Play the animation.";static playbackRate=8;static playbackRateTooltip="The playback rate of the animation in frames per second.";static noSamplesLabel="No samples yet. When you generate one or more images, their thumbnails will appear here.";constructor(t,e=[],s=!1){super(t),this.loopAnimationCallbacks=[],this.playAnimationCallbacks=[],this.setActiveCallbacks=[],this.setPlaybackRateCallbacks=[],this.imageViews=[],this.isAnimation=s,this.samples=e,this.activeIndex=0,this.playbackRate=this.constructor.playbackRate,this.playbackRateInput=new NumberInputView(t,"playbackRate",{min:1,max:60,value:this.constructor.playbackRate,tooltip:this.constructor.playbackRateTooltip,allowNull:!1}),this.playbackRateInput.onChange((()=>this.setPlaybackRate(this.playbackRateInput.getValue(),!1)))}onLoopAnimation(t){this.loopAnimationCallbacks.push(t)}onPlayAnimation(t){this.playAnimationCallbacks.push(t)}onSetActive(t){this.setActiveCallbacks.push(t)}onSetPlaybackRate(t){this.setPlaybackRateCallbacks.push(t)}setIsAnimation(t){this.isAnimation=t,isEmpty(this.node)||(t?this.node.addClass("animation"):this.node.removeClass("animation"))}setLoopAnimation(t,e=!0){for(let e of this.loopAnimationCallbacks)e(t);if(!isEmpty(this.node)&&e){let e=this.node.find(".loop");t?e.addClass("active"):e.removeClass("active")}}setPlayAnimation(t,e=!0){for(let e of this.playAnimationCallbacks)e(t);if(!isEmpty(this.node)&&e){let e=this.node.find(".play");t?e.addClass("active"):e.removeClass("active")}}setActiveIndex(t,e=!0){if(this.activeIndex=t,e)for(let e of this.setActiveCallbacks)e(t);if(!isEmpty(this.imageViews))for(let e in this.imageViews){let s=this.imageViews[e];e++==t?s.addClass("active"):s.removeClass("active")}}setPlaybackRate(t,e=!0){this.playbackRate=t;for(let e of this.setPlaybackRateCallbacks)e(t);e&&this.playbackRateInput.setValue(t,!1)}async setSamples(t){let e=!isEquivalent(this.samples,t);if(this.samples=t,!isEmpty(this.node)){let t=await this.node.find(".samples");if(isEmpty(this.samples))t.content(E.div().class("no-samples").content(this.constructor.noSamplesLabel)),this.imageViews=[];else if(e){let t=await this.node.find(".samples"),e=!1;isEmpty(this.imageViews)&&(t.empty(),e=!0);for(let s in this.samples){let i,a,l=this.samples[s];if(this.imageViews.length<=s?(i=new ImageView(this.config,l,!1),await i.waitForLoad(),a=await i.getNode(),a.on("click",(()=>{this.setActiveIndex(s)})),this.imageViews.push(i),t.append(a),e=!0):(i=this.imageViews[s],i.setImage(l),await i.waitForLoad(),a=await i.getNode()),null!==this.activeIndex&&this.activeIndex==s?i.addClass("active"):i.removeClass("active"),this.isAnimation){let t=100/this.samples.length;a.css("width",`${t}%`)}else a.css("width",null)}e&&t.render()}}}async build(){let t,e,s=await super.build(),i=E.i().addClass("loop").addClass(this.constructor.loopIcon).data("tooltip",this.constructor.loopTooltip).on("click",(()=>{i.toggleClass("active"),this.setLoopAnimation(i.hasClass("active"),!1)})),a=E.i().addClass("play").addClass(this.constructor.playIcon).data("tooltip",this.constructor.playTooltip).on("click",(()=>{a.toggleClass("active"),this.setPlayAnimation(a.hasClass("active"),!1)})),l=E.div().class("samples"),o=!1,n=t=>{let e=l.element.getBoundingClientRect(),s=t.clientX<e.left?0:t.clientX>e.left+e.width?1:(t.clientX-e.left)/e.width;return Math.min(Math.floor(s*this.samples.length),this.samples.length-1)};if(l.on("wheel",(t=>{t.preventDefault(),l.element.scrollLeft+=t.deltaY/10})).on("touchstart",(s=>{t={x:s.touches[0].clientX,y:s.touches[0].clientY},e=l.element.scrollLeft})).on("touchmove",(s=>{let i={x:s.touches[0].clientX,y:s.touches[0].clientY};if(isEmpty(t))t=i,e=l.element.scrollLeft;else{let s={x:i.x-t.x,y:i.y-t.y};l.element.scrollLeft=e-s.x}})).on("mousedown",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),o=!0,this.setActiveIndex(n(t)),bindMouseUntilRelease((t=>{o&&this.setActiveIndex(n(t))}),(t=>{o=!1})))})).on("mousemove",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),o&&this.setActiveIndex(n(t)))})).on("mouseup",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),o=!1)})),isEmpty(this.samples))l.append(E.div().class("no-samples").content(this.constructor.noSamplesLabel));else for(let t in this.samples){let e,s,i=this.samples[t];this.imageViews.length<=t?(e=new ImageView(this.config,i,!1),s=await e.getNode(),s.on("click",(()=>{this.setActiveIndex(t)})),this.imageViews.push(e)):(e=this.imageViews[t],e.setImage(i),s=await e.getNode()),null!==this.activeIndex&&this.activeIndex===t?e.addClass("active"):e.removeClass("active"),l.append(s)}return s.content(l,E.div().class("playback-rate").content(await this.playbackRateInput.getNode(),E.span().content("fps")),i,a),this.isAnimation&&s.addClass("animation"),s}}export{SampleChooserView};
